@ECHO OFF
::
:: This is Davids and Arnes "TelliCastStatsColletor.cmd" script polished
:: USES PROGRAMS: GetUtcDateTimeString.exe, TelliCastStats.exe, wget.exe
:: (the script must be scheduled to run every hour at minutes 29 and 59)
::
:: Version 3.0    March 11th 2016     (c) Ernst Lobsiger     License GPL
::
:: BEGIN of Parameter Section >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
::
:: This should run locally on an EumetCast receiver or over a network from
:: a central statistics collection PC. No name to IP resolution is assumed.
:: If you set interface_address=A.B.C.D in cast-client.ini then "localhost"
:: will not work and you have to set MyIP to the address of your interface.
::
set Node=Alta
set MyIP=localhost
set Port=2517
set StatsDir=E:\EUMETCast
::
::::::::=<---Describe your system. But do not make your text longer than this! --->
set Recv=Quad Inverto Black Ultra, TBS6908 PCIe card, TelliCast client(s) 2.12.1-11
set Desc=Receives BS+HVS + does image and film processing ...      (BS stats shown)
::
::::::::=<---This is a delimiter. You may change the character but length must be 80 --->
set Deli=--------------------------------------------------------------------------------
::
::<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< END of Parameter Section


:: Set the two environment variables MyDate and MyTime to UTC
for /f "tokens=1-5 delims=/:. " %%i in ('GetUtcDateTimeString') do (
set MyDate=%%i-%%j-%%k
set MyTime=%%l:%%m
)

:: Set the name of the output file for all output
set File="%statsdir%\TCstats_%Node%_%MyDate%.txt"

IF %MyTime% == 00:29  CALL :NewDay

CALL :AddLine

IF %MyTime% == 23:59  CALL :MidnightReset

GOTO :EOF


:NewDay
  echo %Deli% > %File%
  echo TelliCastStatsCollector.cmd   (A script for Windows)                 Version 3.0 >> %File%
  echo (c) David Taylor, Arne van Belle, and Ernst Lobsiger                 License GPL >> %File%
  echo. >> %File%
  echo NODE: %Node% >> %File%
  echo RECV: %Recv% >> %File%
  echo DESC: %Desc% >> %File%
  echo %Deli% >> %File%
  echo YearMonDay   -UTC-    Missed    Recov.      Lost      Received          Received >> %File%
  echo YYYY-MM-DD   hh:mm   Packets   Packets   Packets       Packets             Bytes >> %File%
GOTO :EOF


:AddLine
  set Line=1
  FOR /F %%I IN ('TelliCastStats %MyIP%:%Port% -ALL') DO CALL :NICE %%I
  set /a Lost=%Miss% - %Reco%
  CALL :NICE %Lost%
  :: Formated output must exactly fit header produced by function NewDay()!
  set Line=%MyDate%   %MyTime%   %Miss%   %Reco%   %Lost%   %Pack%   %Byte%
  echo %Line% >> %File%
GOTO :EOF


:NICE
  :: Format big numbers nice
  set tail=
  set numb=                %1
  set lead=%numb:~-4,-3%
  :CONT
  if "%lead%"==" " goto DONE
  set tail='%numb:~-3%%tail%
  set numb=%numb:~0,-3%
  set lead=%numb:~-4,-3%
  goto CONT
  :DONE
  set numb=%numb%%tail%
  if "%Line%"=="1" set Reco=%numb:~-7%
  if "%Line%"=="2" set Miss=%numb:~-7%
  if "%Line%"=="3" set Byte=%numb:~-15%
  if "%Line%"=="4" set Pack=%numb:~-11%
  if "%Line%"=="5" set Lost=%numb:~-7%
  set /a Line=%Line%+1
GOTO :EOF


:MidnightReset
  set Line=http://%MyIP%:%port%/www/tsl/receiver/reset_tc_statistics.cgi
  C:\Tools\wget\bin\wget %Line% -t 3 -O nul
  echo %Deli% >> %File%
GOTO :EOF

